unit atlas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls;

const
      posun_x = 10;
      posun_y = 100;
      font_ = 4;

type
  TMesto = record
    nazev : shortstring;
    polohaX, polohaY : smallint;
  end;
  TMesta = array [0..0] of TMesto;
  PMesta = ^TMesta;

  TCesta = record
    z, _do : shortstring;
    vzdalenost, prumernaRychlost : Word;
  end;
  TCesty = array [0..0] of TCesta;
  PCesty = ^TCesty;

  TSpotreba = record
    rychlost : word;
    litru : single;
  end;
  TSpotreby = array [0..0] of TSpotreba;
  PSpotreby = ^TSpotreby;

  PDalsi = ^TDalsi;

  TItemMesto = record
    pred  : integer;
    index : integer;
    dalsi : PDalsi;
    pocet : integer;
  end;

  TDalsi = array [0..0] of TItemMesto;

  TFAutoatlas = class(TForm)
    Open: TOpenDialog;
    Save: TSaveDialog;
    Mapa: TImage;
    btnOpen: TButton;
    btnSaveWay: TButton;
    SouborIn: TRichEdit;
    DrawWays: TCheckBox;
    btnZoomIn: TButton;
    btnZoomOut: TButton;
    grf_rchlst: TCheckBox;
    lbMesta: TListBox;
    mmInfo: TMemo;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnOpenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MapaMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure DrawWaysClick(Sender: TObject);
    procedure btnZoomInClick(Sender: TObject);
    procedure btnZoomOutClick(Sender: TObject);
    procedure lbMestaClick(Sender: TObject);
    procedure MapaMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    Mesta : PMesta;
    Mest  : Integer;
    Cesty : PCesty;
    Cest  : Integer;
    Spotreby : PSpotreby;
    Spotreb  : Integer;
    hledat_z, hledat_do: integer;
    btn_z, btn_do: boolean;

    procedure NastavBarviMapy(const Pen, Brush : TColor);
    procedure ResetMesta( Velikost : integer);
    procedure ResetCesty( Velikost : integer);
    procedure ResetSpotreby( Velikost : integer);
    procedure RedrawMap;
    function NajdiMesto(nazev: string) : integer;
    function VyhledatCestu(Z:Integer; _DO: Integer): PDalsi;
    { Public declarations }
  end;

var
  FAutoatlas: TFAutoatlas;
  zoom : integer = 1;
implementation

{$R *.dfm}

function StrToSingle(Str: string): single;
var pomS : string;
    pomValue : integer;

function NaNtou : integer;
var i, x : integer;
begin
 x := 1;
 for i := 0 to Length(pomS)-1 do
  x := X * 10;
 result := x;
end;
begin
  if Pos('.',str) > 0 then
  begin
  pomS := Copy(Str,1,Pos('.',str) - 1);
  pomValue := StrToInt(pomS);
  pomS := Copy(Str,Pos('.',str) + 1,Length(Str) - Pos('.',str));
  Result := pomValue + StrToInt(pomS)/NaNtou;
  end
  else
  Result := StrToInt(str);
end;

function RemoveFromStr(str, begStr, endStr: string) : string;
begin
  Result := Copy(str, Pos(begStr,str) + Length(begStr), Pos(endStr,str)-(Pos(begStr,str) + Length(begStr)));
end;

function TFAutoatlas.NajdiMesto(nazev: string) : integer;
var index : integer;
begin
  for index := 0 to Mest- 1 do
    if Mesta[index].nazev = nazev then
      begin
        Result := index;
        exit;
      end;
  result := 0;
end;

procedure TFAutoatlas.RedrawMap;
var i, z,_do : integer;

begin
  NastavBarviMapy(clWhite, clWhite);
  Mapa.Canvas.FillRect(Rect(0,0,Mapa.Width, Mapa.Height));
  NastavBarviMapy(clBlack,clWhite);
  Mapa.Canvas.Pen.Width := 5;
  for i := 0 to Mest - 1 do
    begin
      Mapa.Canvas.MoveTo(Mesta[i].polohaX*zoom+posun_x*zoom,Mesta[i].polohaY*zoom+posun_y*zoom);
      Mapa.Canvas.LineTo(Mesta[i].polohaX*zoom+posun_x*zoom,Mesta[i].polohaY*zoom+posun_y*zoom);
      Mapa.Canvas.Font.Size := font_*zoom;
      Mapa.Canvas.Font.Color := clSilver;
      Mapa.Canvas.Brush.Style := bsClear;
      Mapa.Canvas.TextOut((Mesta[i].polohaX*zoom+posun_x*zoom)-Mapa.Canvas.TextWidth(Mesta[i].nazev) shr 1,(Mesta[i].polohaY*zoom+posun_y*zoom)-Mapa.Canvas.TextHeight(Mesta[i].nazev)-2,Mesta[i].nazev );
    end;

  if DrawWays.Checked then
    begin
      NastavBarviMapy(clBlack,clWhite);
      Mapa.Canvas.Pen.Width := 1;
      if grf_rchlst.Checked then
      for i := 0 to Cest - 1 do
        begin
          z := NajdiMesto(Cesty[i].z);
          _do := NajdiMesto(Cesty[i]._do);
          Mapa.Canvas.MoveTo(Mesta[z].polohaX*zoom+posun_x*zoom,Mesta[z].polohaY*zoom+posun_y*zoom);
          Mapa.Canvas.LineTo(Mesta[_do].polohaX*zoom+posun_x*zoom,Mesta[_do].polohaY*zoom+posun_y*zoom);
        end
      else
      begin
      for i := 0 to Cest - 1 do
        begin
          z := NajdiMesto(Cesty[i].z);
          _do := NajdiMesto(Cesty[i]._do);
          Mapa.Canvas.MoveTo(Mesta[z].polohaX*zoom+posun_x*zoom,Mesta[z].polohaY*zoom+posun_y*zoom);
          Mapa.Canvas.LineTo(Mesta[_do].polohaX*zoom+posun_x*zoom,Mesta[_do].polohaY*zoom+posun_y*zoom);
        end
      end;
    end;
end;

procedure TFAutoatlas.ResetMesta( Velikost : integer);
begin
  if Velikost > 0 then
  begin
    if Mesta <> nil then FreeMem(Mesta);
    Mest := Velikost;
    Mesta := AllocMem(Mest*SizeOf(TMesto));
  end
  else
  begin
    Mest := 0;
    if Mesta <> nil then FreeMem(Mesta);
    Mesta := nil;
  end;
end;

procedure TFAutoatlas.ResetCesty( Velikost : integer);
begin
  if Velikost > 0 then
  begin
    if Cesty <> nil then FreeMem(Cesty);
    Cest := Velikost;
    Cesty := AllocMem(Cest*SizeOf(TCesta));
  end
  else
  begin
    Cest := 0;
    if Cesty <> nil then FreeMem(Cesty);
    Cesty := nil;
  end;
end;

procedure TFAutoatlas.ResetSpotreby( Velikost : integer);
begin
  if Velikost > 0 then
  begin
    if Spotreby <> nil then FreeMem(Spotreby);
    Spotreb := Velikost;
    Spotreby := AllocMem(Spotreb*SizeOf(TSpotreba));
    FillChar(Spotreby^,Spotreb*SizeOf(TSpotreba),0);
  end
  else
  begin
    Spotreb := 0;
    if Spotreby <> nil then FreeMem(Spotreby);
    Spotreby := nil;
  end;
end;


procedure TFAutoatlas.NastavBarviMapy(const Pen, Brush : TColor);
begin
 Mapa.Canvas.Pen.Color := Pen;
 Mapa.Canvas.Brush.Color := Brush;
end;

procedure TFAutoatlas.FormCreate(Sender: TObject);
begin
 ResetMesta(0);
 ResetCesty(0);
 ResetSpotreby(0);
 NastavBarviMapy(clWhite, clWhite);
 Mapa.Canvas.FillRect(Rect(0,0,Mapa.Width, Mapa.Height));
 hledat_z := -1;
 hledat_do:= -1;
 btn_z := false;
 btn_do:= false;
end;

procedure TFAutoatlas.btnOpenClick(Sender: TObject);
var LineIndex , mst_i, cst_i, sptrb_i: Integer;
    Count : Integer;
begin
  if not Open.Execute then Exit;
  if not FileExists(Open.FileName) then Exit;
  SouborIn.Lines.Clear;
  SouborIn.Lines.LoadFromFile(Open.FileName);

  for LineIndex := 0 to SouborIn.Lines.Count-1 do
    begin
      if Pos('<mesto>', SouborIn.Lines[LineIndex]) > 0 then Inc(Count) else
       if Pos('</mesta>', SouborIn.Lines[LineIndex]) > 0  then Break;
    end;
    ResetMesta(Count);

  for LineIndex := 0 to SouborIn.Lines.Count-1 do
    begin
      if Pos('<cesta>', SouborIn.Lines[LineIndex]) > 0 then Inc(Count) else
       if Pos('</cesty>', SouborIn.Lines[LineIndex]) > 0  then Break;
    end;
    ResetCesty(Count);

  for LineIndex := 0 to SouborIn.Lines.Count-1 do
    begin
      if Pos('<spotreba>', SouborIn.Lines[LineIndex]) > 0 then Inc(Count) else
       if Pos('</spotreby>', SouborIn.Lines[LineIndex]) > 0  then Break;
    end;
    ResetSpotreby(Count);

  mst_i := 0; cst_i := 0; sptrb_i := 0;
  for LineIndex := 0 to SouborIn.Lines.Count-1 do
    begin
     if mst_i > -1 then
     begin
       if Pos('<mesto>',SouborIn.Lines[LineIndex]) > 0 then inc(mst_i) else
        if Pos('<nazev>',SouborIn.Lines[LineIndex]) > 0 then Mesta[mst_i-1].nazev := RemoveFromStr(SouborIn.Lines[LineIndex],'<nazev>','</nazev>') else
         if Pos('<polohaX>',SouborIn.Lines[LineIndex]) > 0 then Mesta[mst_i-1].polohaX := StrToInt(RemoveFromStr(SouborIn.Lines[LineIndex],'<polohaX>','</polohaX>')) else
          if Pos('<polohaY>',SouborIn.Lines[LineIndex]) > 0 then Mesta[mst_i-1].polohaY := StrToInt(RemoveFromStr(SouborIn.Lines[LineIndex],'<polohaY>','</polohaY>')) else
           if Pos('</mesta>',SouborIn.Lines[LineIndex]) > 0 then mst_i := -1;
     end else
     if cst_i > -1 then
     begin
       if Pos('<cesta>',SouborIn.Lines[LineIndex]) > 0 then inc(cst_i) else
        if Pos('<z>',SouborIn.Lines[LineIndex]) > 0 then Cesty[cst_i-1].z := RemoveFromStr(SouborIn.Lines[LineIndex],'<z>','</z>') else
         if Pos('<do>',SouborIn.Lines[LineIndex]) > 0 then Cesty[cst_i-1]._do := (RemoveFromStr(SouborIn.Lines[LineIndex],'<do>','</do>')) else
          if Pos('<vzdalenost>',SouborIn.Lines[LineIndex]) > 0 then Cesty[cst_i-1].vzdalenost := StrToInt(RemoveFromStr(SouborIn.Lines[LineIndex],'<vzdalenost>','</vzdalenost>')) else
           if Pos('<prumernaRychlost>',SouborIn.Lines[LineIndex]) > 0 then Cesty[cst_i-1].prumernaRychlost := StrToInt(RemoveFromStr(SouborIn.Lines[LineIndex],'<prumernaRychlost>','</prumernaRychlost>')) else
            if Pos('</cesty>',SouborIn.Lines[LineIndex]) > 0 then cst_i := -1;
     end else
     if sptrb_i > -1 then
     begin
       if Pos('<spotreba>',SouborIn.Lines[LineIndex]) > 0 then inc(sptrb_i) else
        if Pos('<rychlost>',SouborIn.Lines[LineIndex]) > 0 then Spotreby[sptrb_i-1].rychlost := StrToInt(RemoveFromStr(SouborIn.Lines[LineIndex],'<rychlost>','</rychlost>')) else
         if Pos('<litru>',SouborIn.Lines[LineIndex]) > 0 then Spotreby[sptrb_i-1].litru := StrToSingle(RemoveFromStr(SouborIn.Lines[LineIndex],'<litru>','</litru>')) else
          if Pos('</spotreby>',SouborIn.Lines[LineIndex]) > 0 then sptrb_i := -1;
     end; 
    end;

    SouborIn.Lines.Clear;
    lbMesta.Items.Clear;
    for LineIndex := 0 to Mest - 1 do
      lbMesta.Items.Add(Mesta[LineIndex].nazev);
    RedrawMap;
end;

procedure TFAutoatlas.FormDestroy(Sender: TObject);
begin
  ResetMesta(0);
  ResetCesty(0);
  ResetSpotreby(0);
end;

procedure TFAutoatlas.MapaMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var i : integer;
    cur : TPoint;
begin
  cur.X := X;
  cur.Y := Y;
  if Mesta = nil then exit;
  for i := 0 to Mest - 1 do
    begin
      if  ((abs(cur.X-(Mesta[i].polohaX*zoom+posun_x*zoom)) < 3) and (abs(cur.y-(Mesta[i].polohaY*zoom+posun_y*zoom)) < 3)) or (lbMesta.ItemIndex = i) then
      Mapa.Canvas.Font.Color := clBlack
      else
      Mapa.Canvas.Font.Color := clSilver;

      Mapa.Canvas.Font.Size := font_*zoom;
      Mapa.Canvas.Brush.Style := bsClear;
      Mapa.Canvas.TextOut((Mesta[i].polohaX*zoom+posun_x*zoom)-Mapa.Canvas.TextWidth(Mesta[i].nazev) shr 1,(Mesta[i].polohaY*zoom+posun_y*zoom)-Mapa.Canvas.TextHeight(Mesta[i].nazev)-2,Mesta[i].nazev );
    end;
end;

procedure TFAutoatlas.DrawWaysClick(Sender: TObject);
begin
  RedrawMap;
end;

procedure TFAutoatlas.btnZoomInClick(Sender: TObject);
begin
  inc(zoom);
  RedrawMap;
end;

procedure TFAutoatlas.btnZoomOutClick(Sender: TObject);
begin
  dec(zoom);
  RedrawMap;
end;

procedure TFAutoatlas.lbMestaClick(Sender: TObject);
var i : integer;
begin
 MapaMouseMove(nil,[],-1,-1);
 mmInfo.Lines.Clear;
 if btn_z then begin hledat_z := lbMesta.ItemIndex; btn_z := false; if (hledat_z = hledat_do) then begin hledat_z := -1; ShowMessage('Clov msto nesm bt stejn jako vchoz!'); btn_z := true; end; end;
 if btn_do then begin hledat_do := lbMesta.ItemIndex; btn_do := false; if (hledat_z = hledat_do) then begin hledat_do := -1; ShowMessage('Clov msto nesm bt stejn jako vchoz!'); btn_do := true;  end; end;

 if (hledat_z > -1) and (hledat_do > -1) then
   Button1.Caption := 'Vyhledat cestu z '+Mesta[hledat_z].nazev +' do '+Mesta[hledat_do].nazev else
   if (hledat_z > -1) then
     Button1.Caption := 'Vyhledat cestu z '+Mesta[hledat_z].nazev +' do...' else
     if (hledat_do > -1) then
       Button1.Caption := 'Vyhledat cestu z... do '+Mesta[hledat_do].nazev;

 for i := 0 to Cest-1 do
   begin
     if Cesty[i].z = Mesta[lbMesta.ItemIndex].nazev then
     begin
       mmInfo.Lines.Add(Mesta[NajdiMesto(Cesty[i]._do)].nazev + '; '+ IntToStr(Cesty[i].vzdalenost)+'km; '+ FloatToStrF(Cesty[i].vzdalenost/Cesty[i].prumernaRychlost,ffNumber,2,2 )+' h' )
     end;

     if Cesty[i]._do = Mesta[lbMesta.ItemIndex].nazev then
     begin
       mmInfo.Lines.Add(Mesta[NajdiMesto(Cesty[i].z)].nazev + '; '+ IntToStr(Cesty[i].vzdalenost)+'km; '+ FloatToStrF(Cesty[i].vzdalenost/Cesty[i].prumernaRychlost,ffNumber,2,2)+' h' )
     end;

   end;
end;

procedure TFAutoatlas.MapaMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i : integer;
    cur : TPoint;
begin
  cur.X := X;
  cur.Y := Y;
  if Mesta = nil then exit;
  for i := 0 to Mest - 1 do
    begin
      if ((abs(cur.X-(Mesta[i].polohaX*zoom+posun_x*zoom)) < 3) and (abs(cur.y-(Mesta[i].polohaY*zoom+posun_y*zoom)) < 3)) then
        begin
          lbMesta.ItemIndex := i;
          lbMestaClick(nil);
        end;

    end;
end;

procedure TFAutoatlas.Button2Click(Sender: TObject);
begin
 btn_z := true;
 btn_do := false;
end;

procedure TFAutoatlas.Button3Click(Sender: TObject);
begin
 btn_z := false;
 btn_do := true;
end;

function TFAutoatlas.VyhledatCestu(Z:Integer; _DO: Integer): PDalsi;
var Zacatek: TItemMesto;
    PomDalsi: PDalsi;
    i : integer;
    pocetdalsich  : integer;
begin
  Zacatek.index := Z;
  Zacatek.Pred := Z;
  pocetdalsich := 0;
  for i := 0 to Cest-1 do
     if (Cesty[i]._do = Mesta[Z].nazev) or (Cesty[i].z = Mesta[Z].nazev) then
     begin
       Inc(pocetdalsich);
     end;
  Zacatek.pocet := pocetdalsich;
  Zacatek.dalsi := AllocMem(pocetdalsich*SizeOf(TItemMesto));
  pocetdalsich := 0;
  for i := 0 to Cest-1 do
     if (Cesty[i]._do = Mesta[Z].nazev) or (Cesty[i].z = Mesta[Z].nazev) then
     begin
       if (Cesty[i]._do = Mesta[Z].nazev) then
         Zacatek.dalsi[pocetdalsich].index := NajdiMesto(Cesty[i].z)
       else
         Zacatek.dalsi[pocetdalsich].index := NajdiMesto(Cesty[i]._do);
       Zacatek.dalsi[pocetdalsich].pred := Z;
       Inc(pocetdalsich);
     end;
end;

procedure TFAutoatlas.Button1Click(Sender: TObject);
begin
  ShowMessage('Funkce nebyla naprogramovna');
end;

end.
